##
## retriver.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 17:52:48 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import urllib, re, sys, string
import time

class HttpRetriever:
    def __init__(self):
        self.source = "Mxtabs.net"
        self.data = list()

    def get_name(self):
        return self.source

    def get_content(self, url):
        fd = urllib.urlopen(url)

        # Get URL content
        t = "".join(fd.readlines())

        fd.close()
        
        return t
    

    def treat_multiple(self, tab, artist, instrument):
        """On this website, a link can be a new search page."""

        # Get the useful part of the webpage
        start = tab.find('<!-- Songs -->')
        tab = tab[start:]

        # Get answers
        l = tab.split('<tr><td nowrap><font size="2" color="#000000"><a href=')

        # Delete useless first element
        l = l[1:]

        for elt in l:
            c = elt.split('<u>')[1].split('</u>')[0] # is a string
            
            if '-' in c: # Artist - Song
                song = c.split('-')[1]
                if not song.startswith(" "): song = " " + song
            else:
                song = c
                if not song.startswith(" "): song = " " + song
                
            link = elt.split('"')[1]

            liste_ratings = ["star1.gif", "star2.gif", "star3.gif", "star4.gif", "star5.gif"]
            for e in liste_ratings:
                if e in elt: rate = str(liste_ratings.index(e) + 1) + "/5"
                else: rate = ""

            self.data.append((artist, song, "", "%s Tab"%instrument, rate, self.source, "net", link))
            
    def query(self, needle):
        begin = time.time()

        needle = needle.replace(" ", "+")
        self.search_it("Guitar", needle)
        self.search_it("Bass", needle)
        self.search_it("Drums", needle)

        print "Mxtabs Search Duration:",time.time()-begin
        
        return self.data

    def search_it(self, instrument, needle):

        tab = self.get_content("http://www.mxtabs.net/search_results.php?search_in=Songs&"
                               "search_text=%s&instrument=%s&Go=Go"%(needle,instrument))

        # No Result
        if "No Tabs Were Found" in tab:
            return []

        # Extract result list
        results = ["Songs Found", "Song Found"]
        for elt in results:
            if elt in tab: start_elt = elt

        start = tab.find(start_elt)
        end = tab.index('</td>', start)
        tab = tab[start:end]

        # Get answers
        rgx = re.compile('<font size="2">.+</font>')
        res = rgx.findall(tab)

        p = res[0]
        l = p.split('<font size="2">')

        # Delete the '' first element
        l = l[1:]

        # Delete useless TAGS
        end_answer = '</font></a><br></font>'
        for k in range(0,len(l),2):
            l[k+1] = l[k+1][:-len(end_answer)]

        for k in range(0, len(l), 2):
            c = l[k+1].split('-')

            if len(c) > 2: # meaning: not only Artist-Song
                artist = c[1]
            else: # Artist-Song
                artist = c[0]
                
            title  = c[-1]
            if not title.startswith(" "): title = " " + title
            
            link = l[k].split('"')[1]
            url = "http://www.mxtabs.net/" + link
            
            content = self.get_content(url)
            if ('<PRE>' not in content) and ('<pre>' not in content): # Not a tab
                self.treat_multiple(content, artist, instrument)
            else: # A tab
                self.data.append((artist, title, "", "%s Tab"%instrument, "", self.source, "net", link))


    def get(self, tabinfo):
        ''' When we ask retriever to grab tab on the net '''
        artist, title, version, type, rate, source, rec, link = tabinfo

        url = "http://www.mxtabs.net/" + link

        print url
        
        fd = urllib.urlopen(url)

        tab = ""
        for line in fd.readlines():
            tab += line.decode("utf8", "replace")

        # Try to get only tab
        # Beware: some pages contain many PRE and/or pre 
        START_PRE = string.rfind(tab, '<PRE>')
        START_pre = string.rfind(tab, '<pre>')

        if START_PRE > START_pre:
            start = START_PRE + 5
            tag = '</PRE>'
        else:
            start = START_pre + 5
            tag = '</pre>'
            
        end = tab.find(tag)
            
        tab = tab[start:end]

        fd.close()

        return tab

