##
## retriver.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 17:52:48 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import urllib, re, sys

class HttpRetriever:
    def __init__(self):
        self.source = "Ultimate-guitar.com"

    def get_name(self):
        return self.source

    def query(self, needle):
        needle = needle.replace(" ", "+")
        fd = urllib.urlopen("http://www.ultimate-guitar.com/search.php3?ss=" + needle + "&w=songs")

        tab = ""
        for line in fd.readlines():
            tab += line.decode("utf8", 'replace')

        # Extract result list
        start = tab.find("<!-- kernel -->")
        end = tab.find("<!-- /kernel -->")
        tab = tab[start:end]

        tab = tab.encode("utf8")

        data = list()

        # Remove useless lines
        rgx = re.compile("<td>* *.+</td>")
        res = rgx.findall(tab)

        # Prepare regex
        rg_artist = re.compile("<td style.+<a.+>.+</a></td>")
        rg_title = re.compile("<td><a href.+</a></td>")
        rg_rate = re.compile("<td><img .+</td>")
        rg_type = re.compile("<td style.+<b>.+</b></td>")

        rate = "-"
        # Extract data
        for el in res:
            print el
            # Artist
            if rg_artist.search(el):
                start = el.find("htm\">") + 5
                end = el.find("</a>")
                artist = el[start:end]
                #print artist

            # Title
            elif rg_title.search(el):
                start = el.find("htm\">") + 5
                end = el.find("</a>")
                title = el[start:end].rstrip(" ")

                # On this site, version is contained in title
                version = ""
                if title[-1:] == ")":
                    ver = sys.version_info
                    
                    # Python2.4                    
                    if int(ver[0]) >= 2 and int(ver[1]) >= 4:
                        split = title.rsplit("(")

                    # Fix for python < 2.4
                    else:
                        split = list()
                        while title.rfind("(") != -1:
                            off = title.rfind("(")
                            split.append(title[off+1:])
                            title = title[:off]
                            
                        if len(split):
                            split.append(title)
                            split.reverse()

                    title = split[0]
                    title = title.rstrip(" ")

                    for ver in split[1:]:
                        ver = ver.rstrip(" ")
                        ver = ver.rstrip(")")

                        if version != "":
                            version += ", "
                            
                        version += ver


                if version == "":
                    version = "ver 1"
                    
                #print title, version

            # Rating
            elif rg_rate.search(el):
                print "RATTE"
                start = el.find("/img/r") + 6
                end = el.find(".gif")
                rate = el[start:end] + "/5"
                print rate

            # Type
            elif rg_type.search(el):
                start = el.find("<b>") + 3
                end = el.find("</b>")
                type = el[start:end]
                if type != "Guitar Pro":
                    if type == "Bass":
                        type = "Bass Tab"
                    elif type == "Guitar":
                        type = "Guitar Tab"
                    elif type == "Chords":
                        type = "Guitar Chords"

                    # Add data !
                    data.append((artist, title, version, type, rate, self.source, "net", None))
                    
                # Reset rate
                rate = "-"

        fd.close()

        return data

    def get(self, tabinfo):
        ''' When we ask retriever to grab tab on the net '''
        artist, title, version, type, rate, source, rec, none = tabinfo
        
        artist = artist.lower()
        artist = artist.replace(" ", "_")
        
        title = title.lower()
        title = title.replace(" ", "_")

        version = version.replace(" ", "")
        version = version.replace(",", "_")
        
        url = "http://www.ultimate-guitar.com/tabs/"
        url += artist[0] + "/"
        url += artist + "/"
        url += title

        if version != "ver1":
            url += "_" + version

        if type == "Guitar Tab":
            url += "_tab"
        elif type == "Bass Tab":
            url += "_btab"
        elif type == "Guitar Chords":
            url += "_crd"

        url += ".htm"

        print url

        fd = urllib.urlopen(url)
        
        tab = ""
        for line in fd.readlines():
            tab += line.decode("utf8", 'replace')

        # Try to get only tab
        off = tab.find("<xmp")
        tab = tab[off:]

        off = tab.find(">")
        tab = tab[off+1:]
        
        off = tab.find("</xmp>")
        tab = tab[:off]
        
        fd.close()

        return tab

