##
## tabview.py
## Login : <glibersat@localhost.localdomain>
## Started on  Tue Jul 19 15:39:59 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import gtk

class TabView(gtk.ScrolledWindow):
    def __init__(self):
        gtk.ScrolledWindow.__init__(self)

        self.contents = gtk.TextView()
        self.contents.set_editable(False)
        self.contents.set_border_window_size(gtk.TEXT_WINDOW_LEFT, 10)
        self.contents.set_border_window_size(gtk.TEXT_WINDOW_RIGHT, 10)
        self.contents.set_border_window_size(gtk.TEXT_WINDOW_TOP, 10)
        self.contents.set_border_window_size(gtk.TEXT_WINDOW_BOTTOM, 10)
        self.add(self.contents)

        vad = self.get_vadjustment()
        # vad.set_value(10)

    def load(self, buffer):
        textbuffer = gtk.TextBuffer()
        textbuffer.create_tag("monospace", family="monospace")
        iter = textbuffer.get_iter_at_offset(0)
        textbuffer.insert_with_tags_by_name(iter, buffer, "monospace", "monospace")
        self.contents.set_buffer(textbuffer)

    def get(self):
        buff = self.contents.get_buffer()
        start = buff.get_start_iter()
        end = buff.get_end_iter()
        text = buff.get_text(start, end)
        return text
